"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@fusion.io/core");
const events_1 = require("events");
let ConsoleKernel = class ConsoleKernel extends events_1.EventEmitter {
    constructor() {
        super(...arguments);
        this.commands = new Set();
    }
    register(Command) {
        this.commands.add(Command);
        return this;
    }
    apply(yargs) {
        yargs
            .option('interactive', {
            alias: 'i',
            description: 'Turn on interactive mode',
            default: false,
            type: 'boolean'
        })
            .option('verbose', {
            alias: 'v',
            describe: 'Set verbosity level',
            default: 2,
            type: 'count'
        });
        this.commands.forEach(CommandConstructor => {
            const cmd = core_1.tokamak.make(CommandConstructor);
            yargs.command(cmd.toYargs());
        });
    }
};
ConsoleKernel = __decorate([
    core_1.singleton()
], ConsoleKernel);
exports.default = ConsoleKernel;
//# sourceMappingURL=ConsoleKernel.js.map