"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@fusion.io/core");
const Config_1 = __importDefault(require("./config/Config"));
const ConsoleKernel_1 = __importDefault(require("./ConsoleKernel"));
const Input_1 = __importDefault(require("./io/Input"));
const Output_1 = __importDefault(require("./io/Output"));
const Inquiry_1 = __importDefault(require("./io/InputHelper/Inquiry"));
const Log_1 = __importDefault(require("./io/OuputHelper/Log"));
const MessageBox_1 = __importDefault(require("./io/OuputHelper/MessageBox"));
const Spinner_1 = __importDefault(require("./io/OuputHelper/Spinner"));
const ProgressBar_1 = __importDefault(require("./io/OuputHelper/ProgressBar"));
const Tasks_1 = __importDefault(require("./io/OuputHelper/Tasks"));
const Table_1 = __importDefault(require("./io/OuputHelper/Table"));
const UI_1 = __importDefault(require("./io/OuputHelper/UI"));
const Tokamak_1 = __importDefault(require("./tokamak/Tokamak"));
class Plasma extends core_1.Plasma {
    compose(consoleKernel, input, output) {
        consoleKernel
            .register(Config_1.default)
            .register(Tokamak_1.default);
        // Input Helpers
        input.extends('inquiry', new Inquiry_1.default());
        // Output Helpers
        output.extends('log', new Log_1.default());
        output.extends('box', new MessageBox_1.default());
        output.extends('spinner', new Spinner_1.default());
        output.extends('progress', new ProgressBar_1.default());
        output.extends('tasks', new Tasks_1.default());
        output.extends('table', new Table_1.default());
        output.extends('ui', new UI_1.default());
    }
}
__decorate([
    core_1.inject(ConsoleKernel_1.default, Input_1.default, Output_1.default),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ConsoleKernel_1.default, Input_1.default, Output_1.default]),
    __metadata("design:returntype", void 0)
], Plasma.prototype, "compose", null);
exports.default = Plasma;
//# sourceMappingURL=Plasma.js.map