"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@fusion.io/core");
const chalk_1 = __importDefault(require("chalk"));
const Command_1 = __importDefault(require("../Command"));
const lodashGet = require("lodash.get");
let Config = class Config extends Command_1.default {
    constructor() {
        super(...arguments);
        this.command = "config [xpath]";
        this.describe = chalk_1.default `Dumps the configuration values with given {cyan xpath}`;
    }
    suggest(answersSoFar, input, config) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!input)
                return Object.keys(config);
            let segments = input.split('.');
            let lastSegment = segments.pop();
            if (!segments.length)
                return Object.keys(config).filter(k => k.startsWith(input));
            const foundValueSoFar = lodashGet(config, segments.join('.'), {});
            return Object.keys(foundValueSoFar)
                .filter(k => k.startsWith(lastSegment))
                .map(v => segments.join('.') + '.' + v);
        });
    }
    interact(argv) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.input.ask('inquiry', [{
                    type: 'autocomplete',
                    name: 'xpath',
                    suggestOnly: true,
                    source: this.suggest
                }]);
        });
    }
    execute({ xpath }, config) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.output.operate('log', xpath ? lodashGet(config, xpath) : config);
        });
    }
};
__decorate([
    core_1.inject('config'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, Object]),
    __metadata("design:returntype", Promise)
], Config.prototype, "suggest", null);
__decorate([
    core_1.inject('config'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], Config.prototype, "execute", null);
Config = __decorate([
    core_1.singleton()
], Config);
exports.default = Config;
//# sourceMappingURL=Config.js.map