"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
const Output_1 = require("../Output");
class MessageBox {
    showing(verbosity, message) {
        return __awaiter(this, void 0, void 0, function* () {
            switch (verbosity) {
                case Output_1.VERBOSITY_ERROR:
                    return console.log(chalk_1.default `{black.bgRed ${message}}`);
                case Output_1.VERBOSITY_INFO:
                    return console.log(chalk_1.default `{black.bgCyan ${message}}`);
                case Output_1.VERBOSITY_DEBUG:
                    return console.log(chalk_1.default `{black.bgMagenta ${message}}`);
                default:
                    return console.log(chalk_1.default `{black.bgGreen ${message} }`);
            }
        });
    }
}
exports.default = MessageBox;
//# sourceMappingURL=MessageBox.js.map