"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ora_1 = __importDefault(require("ora"));
class Spinner {
    showing(verbosity, controlPromise, title = '') {
        return __awaiter(this, void 0, void 0, function* () {
            const spinner = ora_1.default(title);
            spinner.start();
            if (controlPromise) {
                return Promise.resolve(controlPromise)
                    .then(message => spinner.succeed(message))
                    .catch(error => spinner.fail(error));
            }
        });
    }
}
exports.default = Spinner;
//# sourceMappingURL=Spinner.js.map