"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@fusion.io/core");
exports.VERBOSITY_OPERATION = 0;
exports.VERBOSITY_ERROR = 1;
exports.VERBOSITY_INFO = 2;
exports.VERBOSITY_DEBUG = 3;
let Output = class Output extends core_1.Manager {
    constructor() {
        super(...arguments);
        this.verbosity = exports.VERBOSITY_OPERATION;
    }
    setVerbosity(verbosity) {
        this.verbosity = verbosity;
        return this;
    }
    show(type, verbosity, ...messages) {
        return this.adapter(type).showing(verbosity, ...messages);
    }
    operate(type, ...messages) {
        return this.show(type, exports.VERBOSITY_OPERATION, ...messages);
    }
    error(type, ...messages) {
        if (this.verbosity >= exports.VERBOSITY_ERROR) {
            return this.show(type, exports.VERBOSITY_ERROR, ...messages);
        }
    }
    info(type, ...messages) {
        if (this.verbosity >= exports.VERBOSITY_INFO) {
            return this.show(type, exports.VERBOSITY_INFO, ...messages);
        }
    }
    debug(type, ...messages) {
        if (this.verbosity >= exports.VERBOSITY_DEBUG) {
            return this.show(type, exports.VERBOSITY_DEBUG, ...messages);
        }
    }
};
Output = __decorate([
    core_1.singleton()
], Output);
exports.default = Output;
//# sourceMappingURL=Output.js.map